<template>
  <el-main>
    <el-row>
      <el-col>
        <router-link class="el-button el-button--primary" to="/admin/users/new">New user</router-link>
      </el-col>
    </el-row>
    <el-row>
      <el-col>
        <el-table :data="users">
          <el-table-column prop="username" label="Username"></el-table-column>
          <el-table-column label="Full name">
            <template slot-scope="scope">
              {{scope.row.profile.firstName}} {{scope.row.profile.lastName}}
            </template>
          </el-table-column>
          <el-table-column prop="createdAt" label="Created at"></el-table-column>
          <el-table-column prop="role" label="Role"></el-table-column>
          <el-table-column label="...">
            <template slot-scope="scope" v-if="scope.row.role != 'superuser'">
              <router-link class="el-button el-button--button el-button--mini" :to="`/admin/users/${scope.row.id}/edit`">Edit</router-link>
            </template>
          </el-table-column>
        </el-table>
      </el-col>
    </el-row>
    <router-view></router-view>
  </el-main>
</template>

<script>
import UsersQuery from '../../../graphql/queries/users'

export default {
  apollo: {
    users: {
      query: UsersQuery,
      variables: { role: null }
    }
  },

  watch: {
    '$route.path'(current) {
      if(current == '/admin/users') this.$apollo.queries.users.refetch()
    }
  },

  data() {
    return { users: [] }
  }
}
</script>
